using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections;
using System.Windows.Forms;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;


namespace PhidgetServer
{
	public class PhidgetServer
	{

		#region ϐ/萔
		//TCPNCAg̐ڑ󂯕tT[o[
		private TcpListener tcpListener = null;
		//T[o[IPi[
		private IPAddress ipAddress = null;
		//T[o[̃|[gi[
		private int port = 0;

		//ڑNCAgi[tO
		private Hashtable clientHolder = new Hashtable();
		//Xbhi[tO
		private Hashtable threadHolder = new Hashtable();
		
		//NCAgɊ蓖ĂbID
		private int clientID = 1; //0̓T[ỗXbh
		//clientID̍ől
		const int CLIENT_ID_MAX = 10;
		//NCAg̍ő哯ڑ
		const int CLIENT_CNT_MAX = 10;
		//\PbgʐM̃obt@TCY
		const int SOCKET_BUFF_SIZE = 64;

		//vOĨtO
		private bool closing = false;

		//TcpClient̃^CAEgݒ(ms)
		private const int RECEIVE_TIMEOUT = 0;//1000
		private const int SEND_TIMEOUT = 1000;

		#endregion

		#region RXgN^/fXgN^
		//RXgN^
		public PhidgetServer(IPAddress ipAddress, int port)
		{
			this.ipAddress = ipAddress;
			this.port = port;
			this.closing = false;
		}

		//fXgN^
		~PhidgetServer()
		{
			Stop();
		}

		#endregion

		#region T[o[̋N/I

		//|[gԍVw肵āCT[oN
		public void Start(int port)
		{
			this.port = port;
			Start();
		}

		//T[o[N
		public bool Start()
		{
			try
			{
				tcpListener= new TcpListener(ipAddress, port);
				tcpListener.Start();

				Thread thread = new Thread(new ThreadStart(Wait));
				threadHolder.Add(0, thread);
				thread.Start() ;

				PrintMessage("T[o[Jn܂D(IP:{0}, Port:{1})", ipAddress, port);
				return true;
			}
			catch(Exception ex)
			{
				PrintError("T[o[̊JnɎs܂D(IP:{0}, Port:{1})", ipAddress, port);
				PrintError(ex.Message);
				return false;
			}
		}

		//T[o[~
		public void Stop()
		{
			if(!closing)
			{
				closing = true;
				CloseAllThreads();
				PrintMessage("T[o[~܂D");
			}
		}
		#endregion

		#region NCAgƂ̒ʐM
		//NCAg̐ڑ܂őҋ@D
		private void Wait()
		{
			try
			{
				while(true)
				{
					//ڑҋ@
					TcpClient client = tcpListener.AcceptTcpClient();	
					
					client.ReceiveTimeout = RECEIVE_TIMEOUT;
					client.SendTimeout = SEND_TIMEOUT;

					if (clientHolder.Count < CLIENT_CNT_MAX )
					{
						while (clientHolder.Contains(clientID))
						{
							if (clientID < CLIENT_ID_MAX)
								Interlocked.Increment(ref clientID);
							else
								clientID = 1;
						}

						Thread thread = new Thread(new ThreadStart(Run));		
		
						lock(this)
						{
							clientHolder.Add(clientID, client);
							threadHolder.Add(clientID, thread);
						}

						//XbhJn
						thread.Start();
						PrintMessage("NCAg({0})ڑ܂D", clientID);
						Thread.Sleep(100); 
					}
			
				}
			} 
			catch(SocketException ex)
			{
			}
			catch(ThreadAbortException ex)
			{
				Thread.ResetAbort();
			}
			catch(Exception ex)
			{
				PrintError(ex.Message);
			}
			finally
			{
				Stop();
			}
		}

		private void Parse(ref string line, string delimiter)
		{
			string [] texts = Regex.Split(line, delimiter);
							
			for(int i= 0;i<texts.Length;i++)
			{
				if(i < texts.Length-1)
				{
					PrintDebug(texts[i]);
					Command.Phidget p = Command.Phidget.Parse(texts[i]);
					if(p != null)
					{
						CreatePhidgetServerEvent(p);
					}
				}
				else
				{
					if(line.EndsWith(delimiter))
					{
						if(texts[i] != "")
						{
							PrintDebug(texts[i]);
							Command.Phidget p = Command.Phidget.Parse(texts[i]);
							if(p != null)
							{
								CreatePhidgetServerEvent(p);
							}
							//CreateRxEvent(texts[i]);
							//PrintMessage(texts[i]);
						}
						line = "";
					}
					else
					{
						line = texts[i];
					}
				}
			}		
		}

		//NCAgƂ̒ʐMD
		private void Run()
		{
			int cID = clientID;
			TcpClient client = (TcpClient)clientHolder[cID];
			StreamReader reader = new StreamReader(client.GetStream(),System.Text.Encoding.ASCII);
			
			char [] buffers;
			string line = "";
			//int cnt = 0;
			
			try
			{	
				while (true) 
				{
					int length = 0;
					buffers = new char[SOCKET_BUFF_SIZE + 1];
					
					try
					{
						length = reader.Read(buffers, 0, SOCKET_BUFF_SIZE);
					}
					catch(IOException ex)
					{
						break;
					}

					if(length == 0)
						break;
					
					line = line + new string(buffers, 0, length);
					Parse(ref line, Command.DELIMITER_LINE);
				}
			}
			catch (SocketException ex)
			{
			}
			catch (ThreadAbortException ex)
			{
				Thread.ResetAbort();	
			}
			catch (Exception ex) 
			{
				PrintError(ex.Message);
			}
			finally
			{
				if(!closing)
				{
					if(client != null)
						client.Close();
			
					clientHolder.Remove(cID);
					threadHolder.Remove(cID);
					PrintMessage("NCAg({0})ؒf܂D", cID);
				}
			}
		}

		//ׂẴNCAgɏ
		public void WriteAllSockets(string message) 
		{
			Byte [] buffers;
			buffers= Encoding.ASCII.GetBytes(message);

			lock(this)
			{
				foreach (TcpClient client in clientHolder.Values) 
				{
					NetworkStream stream = client.GetStream();
					if(stream.CanWrite)
						stream.Write(buffers, 0 , buffers.Length);
				}	
			}
			Thread.Sleep(100);
		}

		//SXbh~
		private void CloseAllThreads()
		{
			if (tcpListener!=null)
			{
				tcpListener.Stop();
				tcpListener = null;
			}

			foreach (TcpClient c in clientHolder.Values) 
			{
				try
				{
					c.Close();
				}
				catch{}
			}

			foreach (Thread t in threadHolder.Values) 
			{
				try
				{
					if(t.IsAlive)
						t.Abort();
				}
				catch{}
			}

			try
			{	
				clientHolder.Clear();
				threadHolder.Clear();
			}
			catch{}
		}

		#endregion

		#region PhidgetServer֘ÃCxĝ߂̃fQ[g/\bh
		
		public delegate void PhidgetServerHandler(object sender, PhidgetServerEventArgs e);
		public event PhidgetServerHandler phidgetServerHandler;

		public class PhidgetServerEventArgs : EventArgs
		{
			private Command.Phidget phidget = null;

			public PhidgetServerEventArgs(Command.Phidget phidget)
			{
				this.phidget = phidget;
			}

			public Command.Phidget Phidget
			{
				get {return this.phidget;}
			}
		}

		//CxgND
		public void CreatePhidgetServerEvent(Command.Phidget phidget)
		{
			if(phidget == null)
				return;

			PhidgetServerEventArgs e = new PhidgetServerEventArgs(phidget);

			if(phidgetServerHandler != null)
				phidgetServerHandler(this, e);

			return;
		}
		#endregion

		#region bZ[WCxĝ߂̃fQ[g/\bh
		
		//PhidgetMessageEventArgs邽߂Delgate
		public delegate void PhidgetMessageHandler(object sender, PhidgetMessageEventArgs e);
		public event PhidgetMessageHandler phidgetMessageHandler;
		
		//bZ[W֘ÃCxg
		public class PhidgetMessageEventArgs : EventArgs
		{
			private string message;
			private bool debug;

			public PhidgetMessageEventArgs(string message)
			{
				this.message = message;
				this.debug = false;
			}

			public PhidgetMessageEventArgs(string message, bool debug)
			{
				this.message = message;
				this.debug = debug;
			}


			public string Message
			{
				get {return this.message;}
			}

			public bool Debug
			{
				get{return this.debug;}
			}
		}

		//G[CxgND
		public void PrintError(string m, params object []args)
		{
			PrintMessage("Error: " + m, args);
		}

		//bZ[WCxgND
		public void PrintMessage(string m, params object []args)
		{
			PhidgetMessageEventArgs e = new PhidgetMessageEventArgs(String.Format(m,args));

			if(phidgetMessageHandler != null)
				phidgetMessageHandler(this, e);

			return;
		}

		public void PrintDebug(string m, params object []args)
		{
			PhidgetMessageEventArgs e = new PhidgetMessageEventArgs(String.Format(m,args), true);

			if(phidgetMessageHandler != null)
				phidgetMessageHandler(this, e);
		}

		#endregion

	}
}
